Subject: Re: [PATCH v8 2/3] pinctrl: pinctrl-microchip-sgpio: Add pinctrl driver for Microsemi Serial GPIO

From: Lars Povlsen <[email-masked]>
Date: Tue, 10 Nov 2020 16:59:12 +0100

Andy Shevchenko writes:

> On Mon, Nov 9, 2020 at 5:27 PM Alexandre Belloni
> <[email-masked]> wrote:
>> On 09/11/2020 17:16:49+0200, Andy Shevchenko wrote:
>> > On Mon, Nov 9, 2020 at 4:32 PM Alexandre Belloni
>> > <[email-masked]> wrote:
>> > > On 09/11/2020 16:17:40+0200, Andy Shevchenko wrote:
>
> ...
>
>> > > > > +               dev_err(pctldev->dev, "Pin %d direction as %s is not possible\n",
>> > > > > +                       pin, input ? "input" : "output");
>> > > >
>> > > > Do we need this noise? Isn't user space getting a proper error code as
>> > > > per doc and can handle this?
>> > >
>> > > Why would userspace get the error code?
>> >
>> > Huh?! Why it shouldn't. How will users know if they are doing something wrong?
>> >
>> > > Userspace should never have to
>> > > handle gpios directly or you are doing something wrong.
>> >
>> > This is true, but check how error codes are propagated to the user space.
>> >
>>
>> your point is to remove an error message because the error may be
>> propagated to userspace. My point is that userspace should never use
>> gpios and the kernel has to be the consumer.
>
> Tell this to plenty of users of old sysfs interface and to libgpiod ones.
> If what you are saying had been true, we would have never had the new
> ABI for GPIOs.
>
>> I don't see how your answer
>> is relevant here.
>
> I have an opposite opinion.
>
>> Did you already check all the call sites from the
>> kernel too?
>
> If you think we have to print a message on each possible error case
> (but not always the one) we will get lost in the messages disaster and
> dmesg overflow.
> It is consumer who should decide if the setting is critical or not to
> be printed to user.

I think the message is a valid one. I will change it to
dev_err_ratelimited() - that should prevent the dmesg flooding.

---Lars

--
Lars Povlsen,
Microchip

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel